function P=comp_p(U,op,gamma)

[n1,n2]=size(U);

n=n1*n2;
u=reshape(U,n,1);



gradu(:,1)= op.GRAD(1:n,:)*u;
gradu(:,2)= op.GRAD(n+1:2*n,:)*u;

srgradu = sum((gradu).^2,2);
etagradu(:,1) = sqrt(srgradu);
etagradu(:,2) = etagradu(:,1);

 
p = gradu./max(etagradu,gamma);
 
P = reshape(p,n1,n2,2);
